#ifndef BWIDGETS_LAYOUT_IMPL_HPP
#define BWIDGETS_LAYOUT_IMPL_HPP

#include <vector>

#include <basic_widgets/w/base/layout.hpp>
#include <basic_widgets/w/base/widget_impl.hpp>

namespace bwidgets
{
    class Renderer;
}

namespace bwidgets
{
    class LayoutImpl : public virtual Layout,
                       public virtual WidgetImpl
    {
    public:
        using WidgetImpl::WidgetImpl;

        void handle_event(const SDL_Event&) override;

    protected:
        void _handle_renderer_change(const std::shared_ptr<Renderer>&) override;
        void _handle_rendering() override;
        void _handle_theme_change(const std::shared_ptr<Theme>&) override;
    };
}

#endif
