#ifndef BWIDGETS_BUTTON_HPP
#define BWIDGETS_BUTTON_HPP

#include <string>

#include <basic_widgets/core/type/color.hpp>
#include <basic_widgets/w/base/widget.hpp>
#include <basic_widgets/w/feat/font_handler.hpp>
#include <basic_widgets/w/feat/mouse_handler.hpp>

namespace bwidgets
{
    class Button : public virtual Widget,
                   public virtual FontHandler,
                   public virtual MouseHandler
    {
    public:
        using Widget::Widget;

        // Get button text (label).
        [[nodiscard]] virtual auto text() const noexcept -> std::string_view = 0;
        // Set button text
        virtual void               text(std::string)                         = 0;
    };
}

#endif
