#ifndef BWIDGETS_DEFAULT_THEME_HPP
#define BWIDGETS_DEFAULT_THEME_HPP

#include <map>
#include <memory>

#include <basic_widgets/w/base/theme.hpp>

namespace bwidgets
{
    class DefaultTheme : public Theme
    {
    public:
        [[nodiscard]] auto color_font_bg() const -> const Color& override;
        [[nodiscard]] auto color_font_fg() const -> const Color& override;
        [[nodiscard]] auto color_input_bg() const -> const Color& override;
        [[nodiscard]] auto color_input_bg_active() const -> const Color& override;
        [[nodiscard]] auto color_input_fg() const -> const Color& override;
        [[nodiscard]] auto color_widget_bg() const -> const Color& override;
        [[nodiscard]] auto color_widget_bg_dark() const -> const Color& override;
        [[nodiscard]] auto color_widget_bg_hl() const -> const Color& override;
        [[nodiscard]] auto color_widget_border() const -> const Color& override;
        [[nodiscard]] auto color_widget_border_pushed() const -> const Color& override;
        [[nodiscard]] auto font(FontEnum) -> const std::shared_ptr<Font>& override;
        [[nodiscard]] auto font_default() -> const std::shared_ptr<Font>& override;
        [[nodiscard]] auto font_default_big() -> const std::shared_ptr<Font>& override;
        [[nodiscard]] auto font_default_bigger()
          -> const std::shared_ptr<Font>& override;
        [[nodiscard]] auto font_default_biggest()
          -> const std::shared_ptr<Font>& override;
        [[nodiscard]] auto font_default_small() -> const std::shared_ptr<Font>& override;
        [[nodiscard]] auto font_default_smaller()
          -> const std::shared_ptr<Font>& override;
        [[nodiscard]] auto font_default_smallest()
          -> const std::shared_ptr<Font>& override;
        [[nodiscard]] auto size_layout_margin() const -> const Size& override;
        [[nodiscard]] auto size_widget_border() const -> int override;

    private:
        static const Color _color_font_bg;
        static const Color _color_font_fg;
        static const Color _color_input_bg;
        static const Color _color_input_bg_active;
        static const Color _color_input_fg;
        static const Color _color_widget_bg;
        static const Color _color_widget_bg_dark;
        static const Color _color_widget_bg_hl;
        static const Color _color_widget_border;
        static const Color _color_widget_border_pushed;
        static const Size  _size_layout_margin;
        static const int   _size_widget_border;

        std::map<FontEnum, std::shared_ptr<Font>> _fonts;
    };
}

#endif
