#ifndef BWIDGETS_SCROLLABLE_AREA_HPP
#define BWIDGETS_SCROLLABLE_AREA_HPP

#include <basic_widgets/w/base/widget.hpp>

#include "basic_widgets/core/texture.hpp"

namespace bwidgets
{
    class ScrollableArea : public virtual Widget
    {
    public:
        enum class Alignment
        {
            BOTTOM_CENTER,
            BOTTOM_LEFT,
            BOTTOM_RIGHT,
            CENTER_CENTER,
            CENTER_LEFT,
            CENTER_RIGHT,
            TOP_CENTER,
            TOP_LEFT,
            TOP_RIGHT
        };

        [[nodiscard]] virtual auto alignment() -> Alignment                     = 0;
        virtual void               alignment(Alignment)                         = 0;
        [[nodiscard]] virtual auto texture() -> const std::shared_ptr<Texture>& = 0;
        virtual void               texture(std::shared_ptr<Texture>)            = 0;
    };
}

#endif
