#ifndef BWIDGETS_SCROLLABLE_AREA_IMPL_HPP
#define BWIDGETS_SCROLLABLE_AREA_IMPL_HPP

#include <basic_widgets/w/base/widget_impl.hpp>
#include <basic_widgets/w/scrollable_area.hpp>
#include <basic_widgets/w/scrollbar.hpp>

namespace bwidgets
{
    class ScrollableAreaImpl : public virtual ScrollableArea,
                               public virtual WidgetImpl
    {
    public:
        ScrollableAreaImpl(Widget* parent = nullptr);

        [[nodiscard]] auto alignment() -> Alignment override;
        void               alignment(Alignment) override;
        void               handle_event(const SDL_Event&) override;
        [[nodiscard]] auto size() const noexcept -> Size override;
        [[nodiscard]] auto texture() -> const std::shared_ptr<Texture>& override;
        void               texture(std::shared_ptr<Texture>) override;

    protected:
        void _handle_geometry_change(const SDL_Rect&) override;
        void _handle_renderer_change(const std::shared_ptr<Renderer>&) override;
        void _handle_rendering() override;
        void _handle_theme_change(const std::shared_ptr<Theme>&) override;

    private:
        Alignment                  _alignment;
        std::shared_ptr<ScrollBar> _scrollbar_h;
        std::shared_ptr<ScrollBar> _scrollbar_v;
        std::shared_ptr<Texture>   _texture;
        SDL_Rect                   _texture_area;
    };
}

#endif
