#ifndef BWIDGETS_SCROLLBAR_HPP
#define BWIDGETS_SCROLLBAR_HPP

#include <functional>

#include <basic_widgets/w/base/widget.hpp>
#include <basic_widgets/w/feat/mouse_handler.hpp>

namespace bwidgets
{
    class ScrollBar : public virtual Widget,
                      public virtual MouseHandler
    {
    public:
        enum class Orientation
        {
            HORIZONTAL,
            VERTICAL
        };

        virtual void               on_scroll(std::function<void(float)>) = 0;
        [[nodiscard]] virtual auto orientation() const -> Orientation    = 0;
        virtual void               orientation(Orientation)              = 0;
        [[nodiscard]] virtual auto step() const -> float                 = 0;
        virtual void               step(float)                           = 0;
        [[nodiscard]] virtual auto value() const -> float                = 0;
        virtual void               value(float)                          = 0;
    };
}

#endif
