#include <basic_widgets/w/base/layout_impl.hpp>

using namespace bwidgets;

void LayoutImpl::handle_event(const SDL_Event& ev)
{
    EventHandlerImpl::handle_event(ev);
    for_widgets([ev](Widget* w) { w->handle_event(ev); });
}

void LayoutImpl::_handle_renderer_change(const std::shared_ptr<Renderer>& r)
{
    for_widgets([r](Widget* w) { w->renderer(r); });
}

void LayoutImpl::_handle_rendering()
{
    for_widgets([](Widget* w) { w->render(); });
}

void LayoutImpl::_handle_theme_change(const std::shared_ptr<Theme>& t)
{
    for_widgets([&t](Widget* w) { w->theme(t); });
}
