#include <basic_widgets/w/feat/font_handler_impl.hpp>

using namespace bwidgets;
using namespace std;

auto FontHandlerImpl::font() const -> const shared_ptr<Font>&
{
    return _font;
}

void FontHandlerImpl::font(shared_ptr<Font> f)
{
    if (f
        && (f != _font || f->family_name != _font->family_name
            || f->height != _font->height || f->hinting() != _font->hinting()
            || f->kerning() != _font->kerning() || f->outline() != _font->outline()
            || f->style_name != _font->style_name))
    {
        _handle_font_change(f);
        _font = std::move(f);
    }
}

auto FontHandlerImpl::font_color_bg() const -> const Color&
{
    return _font_color_bg;
}

void FontHandlerImpl::font_color_bg(const Color& c)
{
    if (c != _font_color_bg) {
        _handle_font_color_change(_font_color_fg, c);
        _font_color_bg = c;
    }
}

auto FontHandlerImpl::font_color_fg() const -> const Color&
{
    return _font_color_fg;
}

void FontHandlerImpl::font_color_fg(const Color& c)
{
    if (c != _font_color_fg) {
        _handle_font_color_change(c, _font_color_fg);
        _font_color_fg = c;
    }
}
