#include <basic_widgets/w/aligned_layout_impl.hpp>
#include <basic_widgets/w/button_impl.hpp>
#include <basic_widgets/w/caption_impl.hpp>
#include <basic_widgets/w/numeric_input_impl.hpp>
#include <basic_widgets/w/scrollable_area_impl.hpp>
#include <basic_widgets/w/scrollbar_impl.hpp>
#include <basic_widgets/w/widget_factory.hpp>

using namespace std;

namespace bwidgets
{
    auto create_horizontal_layout(Widget* parent) -> shared_ptr<AlignedLayout>
    {
        return make_shared<AlignedLayoutImpl<LayoutAlignment::HORIZONTAL>>(parent);
    }

    auto create_vertical_layout(Widget* parent) -> shared_ptr<AlignedLayout>
    {
        return make_shared<AlignedLayoutImpl<LayoutAlignment::VERTICAL>>(parent);
    }

    auto create_button(Widget* parent) -> shared_ptr<Button>
    {
        return make_shared<ButtonImpl>(parent);
    }

    auto create_caption(Widget* parent) -> shared_ptr<Caption>
    {
        return make_shared<CaptionImpl>(parent);
    }

    auto create_input_float(Widget* parent) -> shared_ptr<NumericInput<float>>
    {
        return make_shared<NumericInputImpl<float>>(parent);
    }

    auto create_scrollable_area(Widget* parent) -> shared_ptr<ScrollableArea>
    {
        return make_shared<ScrollableAreaImpl>(parent);
    }

    auto create_scrollbar(Widget* parent) -> shared_ptr<ScrollBar>
    {
        return make_shared<ScrollBarImpl>(parent);
    }

    auto create_input_int(Widget* parent) -> shared_ptr<NumericInput<int>>
    {
        return make_shared<NumericInputImpl<int>>(parent);
    }
}
